From e6f6214c002b6ce94142002f2d6b043b83cabf7d Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 22 2020 00:26:41 +0000
Subject: [PATCH 1776/2232] Store enum variant name as Pair


---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 315fb35..7da60ac 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -342,7 +342,7 @@ fn write_enum<'a>(out: &mut OutFile<'a>, enm: &'a Enum) {
     write_atom(out, enm.repr);
     writeln!(out, " {{");
     for variant in &enm.variants {
-        writeln!(out, "  {} = {},", variant.ident, variant.discriminant);
+        writeln!(out, "  {} = {},", variant.name.cxx, variant.discriminant);
     }
     writeln!(out, "}};");
     writeln!(out, "#endif // {}", guard);
@@ -365,7 +365,7 @@ fn check_enum<'a>(out: &mut OutFile<'a>, enm: &'a Enum) {
         writeln!(
             out,
             ">({}::{}) == {}, \"disagrees with the value in #[cxx::bridge]\");",
-            enm.name.cxx, variant.ident, variant.discriminant,
+            enm.name.cxx, variant.name.cxx, variant.discriminant,
         );
     }
 }
diff --git a/macro/src/derive.rs b/macro/src/derive.rs
index 5e9b8a9..5b8f259 100644
--- a/macro/src/derive.rs
+++ b/macro/src/derive.rs
@@ -230,7 +230,7 @@ fn enum_clone(enm: &Enum, span: Span) -> TokenStream {
 fn enum_debug(enm: &Enum, span: Span) -> TokenStream {
     let ident = &enm.name.rust;
     let variants = enm.variants.iter().map(|variant| {
-        let variant = &variant.ident;
+        let variant = &variant.name.rust;
         let name = variant.to_string();
         quote_spanned! {span=>
             #ident::#variant => formatter.write_str(#name),
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 433eca6..40c1161 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -268,7 +268,7 @@ fn expand_enum(enm: &Enum) -> TokenStream {
     let repr = enm.repr;
     let type_id = type_id(&enm.name);
     let variants = enm.variants.iter().map(|variant| {
-        let variant_ident = &variant.ident;
+        let variant_ident = &variant.name.rust;
         let discriminant = &variant.discriminant;
         Some(quote! {
             pub const #variant_ident: Self = #ident { repr: #discriminant };
diff --git a/syntax/ident.rs b/syntax/ident.rs
index aaf7832..47aae14 100644
--- a/syntax/ident.rs
+++ b/syntax/ident.rs
@@ -32,7 +32,7 @@ pub(crate) fn check_all(cx: &mut Check, apis: &[Api]) {
             Api::Enum(enm) => {
                 check_ident(cx, &enm.name);
                 for variant in &enm.variants {
-                    check(cx, &variant.ident);
+                    check(cx, &variant.name.rust);
                 }
             }
             Api::CxxType(ety) | Api::RustType(ety) => {
diff --git a/syntax/mod.rs b/syntax/mod.rs
index 4cedc28..7f8fd9a 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -159,7 +159,7 @@ pub struct Receiver {
 }
 
 pub struct Variant {
-    pub ident: Ident,
+    pub name: Pair,
     pub discriminant: Discriminant,
     pub expr: Option<Expr>,
 }
diff --git a/syntax/parse.rs b/syntax/parse.rs
index e8bef90..8429d80 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -212,10 +212,12 @@ fn parse_variant(variant: RustVariant, discriminants: &mut DiscriminantSet) -> R
         Ok(discriminant) => discriminant,
         Err(err) => return Err(Error::new_spanned(variant, err)),
     };
+
+    let name = pair(Namespace::ROOT, &variant.ident, None, None);
     let expr = variant.discriminant.map(|(_, expr)| expr);
 
     Ok(Variant {
-        ident: variant.ident,
+        name,
         discriminant,
         expr,
     })

